/* main c program testpro.c */
/* expro-40 testing program V1.0 */
/* By Grason Kirk 5/30/88 */
/* rev v1.00  */

#include <testpro.dcl>
/*=========================================================*/
#define VIDEO 0x10 /* INT 10H */
#define VCCID 0xe7 /* VCC D/A value port bit0 ckpus,bit1 enck */
#define CODEID 0xf8 /* ID CODE port */
#define SEL16  0xe8 /* select chip 16 */
/*=========================================================*/
unsigned short htou();
unsigned long htoul();
int pwron=FALSE;
int cardok=0;

int ioadrno =0x0e;/* 0-f 200 2f0 io base address of SAC-101*/
int ioadr,idport,dataport;

/*=========================================================*/
main()
{
  int ch,i;
  FILE *datafp;

  chkclk();/* check system clk */
  ioadr=0x0200+ioadrno*16;
  idport=ioadr;
  dataport=ioadr+2;
  initio();
/*---------------------------------------------------------*/
/* main program realy start here                           */
/*---------------------------------------------------------*/
  ch=0;
  while (TRUE) {
    clscrn(0,0,24,79);
    locate(0,0);
      printf("SUNSHINE Device Programmer\n");
      printf("MODEL: EXPRO-40 (C) 1988\n");
      printf("TEST PROGRAM  V1.00\n");

    if(pwron==FALSE){
      if(chkcur(0,0,'S')!=0 || chkcur(0,1,'U')!=0 || \
        chkcur(0,2,'N')!=0 || chkcur(0,3,'S')!=0 || \
        chkcur(0,4,'H')!=0 || chkcur(0,5,'I')!=0 || \
        chkcur(0,6,'N')!=0 || chkcur(0,7,'E')!=0 || \
        chkcur(0,8,' ')!=0 || chkcur(0,9,'D')!=0 || \
   chkid(31,0x07)!=0 || chkid(23,0x02)!=0 || \
   chkid(3,0x0b)!=0 || chkid(22,0x09)!=0 || \
   chkid(11,0x08)!=0 ){

        clscrn(0,0,24,79);
        locate(10,0);
          printf("Error Identification on hardware!\n\n");
          printf("May be mismatched between DIPSW position on SAC-101 and\n");
          printf("                              I/O base adr. on software\n");
          printf("Press <Q> to Quit\n");
          printf("or press <CR> to continue testing program ...");
        while(TRUE){
          while((ch=getch())=='\0')
            getch();
          if(ch=='q' || ch=='Q')
            exit();
          if(ch==CR || ch==LF){
       pwron=TRUE;
       break;
     }
   }
   continue;
}
else {
   cardok=1;/* card exist*/
   pwron=TRUE;
}
}
	printf("------------  Main Menu  -------------\n");
        printf("C. Change I/O base adr. of SAC-101\n");
	printf("Q. Quit\n");
        printf("\n");

        printf("Bottom board test program :\n");
	printf("1. Power supply test\n");
	printf("2. Voltage adjustment\n");
        printf("\n");

        printf("Test-socket test program :\n");
	printf("3. GND pin test\n");
	printf("4. VCC pin test\n");
        printf("5. VHH pin test\n");
        printf("6. VOP pin test\n");
        printf("7. I/O pin test\n");
        printf("8. Extra pin test\n");
        printf("--------------------------------------\n");
        printf("\n");

        printf("NOTE : Don't place any device into\n");
        printf("       test-socket\n");

while(TRUE){
clscrn(24,0,24,79);
locate(24,0);
printf("Select which function ? ");

while((ch=getch())==0)
  getch(); /* neglect extended code */
putch(ch);
ch=toupper(ch);

switch(ch) {
case '1': power_menu();
          break;
case '2': adj_menu();
	  break;
case '3': gndtest();
	  break;
case '4': vcctest();
          break;
case '5': vhhtest();
	  break;
case '6': voptest();
	  break;
case '7': iotest();
	  break;
case '8': xtratest();
	  break;

case 'C': io_manu();/* change i/o address */
	  break;
case 'D': datatest();/* bottom board data test */
	  break;
case 'S': seltest();/* bottom board chip select test */
	  break;

case 'Q':
          initio();
          exit();
} /* switch loop end */
if(ch=='4' || ch=='5' || ch=='6'|| ch=='7' || ch=='8')
  break;
}/* while select number */

} /* main while loop end */
} /* main end */
/*==============================================================*/
/*    function procedure here */
/*==============================================================*/
seltest()
{
  int i,j,k;

  for(i=0;i<16;i++)
  {
    outp(idport,SEL16+i);
    for(j=0;j<1000;j++)
      for(k=0;k<40;k++)
        outp(dataport,0);
  }
}
/*------------------------------------*/
datatest()
{
  int i,j,k,d;

  for(i=0;i<8;i++)
  {
    outp(idport,SEL16+16);
    d=!(0x01 << i);
    for(j=0;j<1000;j++)
      for(k=0;k<40;k++)
        outp(dataport,d);
  }
}
/*==============================================================*/
io_manu()
{
  int i,ch;

  window(10,40,23,79);
  locate(10,45);
    printf(" CHANGE I/O BASE ADR OF SAC-101 ");

  for(i=0;i<8;i++){
    locate(11+i,42);
      printf("%hX",i);
      printf(".");
    locate(11+i,45);
      printf("%hX",0x0200+16*i);
    locate(11+i,60);
      printf("%hX",i+8);
      printf(".");
    locate(11+i,63);
      printf("%hX",0x200+16*(i+8));

  }
  locate(19,42);
    printf("<CR> back to main menu.");

  while(TRUE) {
  clscrn(20,41,22,78);
  locate(20,41);
    printf("Current I/O base-adr: %hX",ioadr);
  locate(21,42);
    if(cardok==1)
      printf("--- Programmer existed ---");
    else printf("--- Programmer not existed ---");

    locate(22,41);
      printf("Select number ? ");
    while((ch=getch())=='\0')
      getch();
    if(ch==CR || ch==LF || ch==ESC){
      clscrn(10,40,23,79);
      return;
    }
    ch=toupper(ch);
    if(ch>='0' && ch<='9')
      ioadrno=ch-'0';
    else if(ch>='A' && ch<='F')
      ioadrno=ch-'A'+10;

      ioadr=0x0200+16*ioadrno;
      initio();

if(chkcur(0,0,'S')!=0 || chkcur(0,1,'U')!=0 || \
   chkcur(0,2,'N')!=0 || chkcur(0,3,'S')!=0 || \
   chkcur(0,4,'H')!=0 || chkcur(0,5,'I')!=0 || \
   chkcur(0,6,'N')!=0 || chkcur(0,7,'E')!=0 || \
   chkcur(0,8,' ')!=0 || chkcur(0,9,'D')!=0 || \
   chkid(31,0x07)!=0 || chkid(23,0x02)!=0 || \
   chkid(3,0x0b)!=0 || chkid(22,0x09)!=0 || \
   chkid(11,0x08)!=0 )
   cardok=0;
else cardok=1;

  }/* while loop end */
clscrn(10,40,23,79);
}
/*---------------------------------------------------------*/
chkid(count,value)
int count,value;
{
  int i;

  outp(ioadr,VCCID);
  outp(ioadr+2,0x00);
  outp(ioadr+2,0x01);/* reset code */
  outp(ioadr+2,0x00);
  outp(ioadr+2,0x02); /* enck */
  for(i=0;i<count;i++)
  {
    outp(ioadr+2,0x03);
    outp(ioadr+2,0x02);
  }
  outp(ioadr+2,0x00);
  outp(ioadr,CODEID);
  if((byte)(value & 0x0f) == (byte)(inp(ioadr+2) & 0x0f))
    return(0);
  else return(-1);
}
/*--------------------------------------------------------------*/
window(x1,y1,x2,y2) /* window frame drawing */
int x1,y1,x2,y2;
{
  int i;
  char horbar='\xc4';
  char vrtbar='\xb3';
  char uplf='\xda';
  char uprt='\xbf';
  char dnlf='\xc0';
  char dnrt='\xd9';

locate(x1,y1);
	putch(uplf);
locate(x1,y2);
	putch(uprt);
locate(x2,y1);
	putch(dnlf);
locate(x2,y2);
	putch(dnrt);

for(i=y1+1;i<y2;i++) {
	locate(x1,i);
		putch(horbar);
	locate(x2,i);
		putch(horbar);
	}
for(i=x1+1;i<x2;i++) {
	locate(i,y1);
		putch(vrtbar);
	locate(i,y2);
		putch(vrtbar);
	}
}
/*--------------------------------------------------------------*/    
/*--------------------------------------------------------------*/
getline(s,lim) /* get 1 line from console */
char s[]; /* return length, NULL len=1 */
int lim; /* max key include newline */
{
  int ch,i;

  i=0;
  while((ch=getch())!=CR && ch!=ESC) {
    if(ch==0)
      getch(); /* extended key neglect next code */
    else {
      if(i==lim-1 && ch!=BS)
        putch(BEL);
      else {
        if(iscntrl(ch)==0) { /* non control key */
        s[i++]=ch;
        putch(ch);
        }
        else if(ch==BS && i!=0) {
          i--;
          putch(ch);
          putch(' ');
          putch(ch);
        }
      }
    }
  } /* while loop end */
  if (ch==ESC) {
    i=0;
    s[i]=ch;
    i++;
  }
  s[i]='\0';
  return(i);
}
/*--------------------------------------------------------------*/
waitms(time) /* time delay 1 ms resolution */
int time;
{
  int i;

  for (i=0;i<time;i++)
     dly1m();
}
/*--------------------------------------------------------------*/
errbeep() /* error 3 beep */
{
        putch(BEL);
        waitms(63);
        putch(BEL);
        waitms(63);
        putch(BEL);
        waitms(63);
}
/*--------------------------------------------------------------*/
unsigned short htou(string)
char *string;
{
  int i;
  unsigned short value;

  value=0;
  i=0;
  while(i<4 && string[i]!='\0' && isxdigit(string[i])!=0)
  {
    if(string[i] >='0' && string[i] <='9')
      value=value*16+(byte)(string[i]-'0');
    else if(string[i] >='A' && string[i] <='F')
      value=value*16+(byte)(string[i]-'A'+10);
    else
      value=value*16+(byte)(string[i]-'a'+10);
    i++;
  }
  return((unsigned short)value);
}
/*--------------------------------------------------------*/
unsigned long htoul(string)
char *string;
{
  int i;
  unsigned long value;

  value=0;
  i=0;
  while(i<8 && string[i]!='\0' && isxdigit(string[i])!=0)
  {
    if(string[i] >='0' && string[i] <='9')
      value=value*16+(byte)(string[i]-'0');
    else if(string[i] >='A' && string[i] <='F')
      value=value*16+(byte)(string[i]-'A'+10);
    else
      value=value*16+(byte)(string[i]-'a'+10);
    i++;
  }
  return((unsigned long)value);
}
/*--------------------------------------------------------*/
utoh(value,string)
unsigned short value;
char *string;
{
  byte temp;
  int i;

  string[4]='\0';
  for(i=4;i>0;i++)
  {
    temp=value % 16;
    value=value/16;
    if(temp>=0 && temp<=9)
      string[i-1]=temp+0x30;
    else string[i-1]=temp+0x37;
  }
}
/*--------------------------------------------------------*/
ultoh(value,string)
unsigned long value;
char *string;
{
  byte temp;
  int i;

  string[8]='\0';
  for(i=8;i>0;i++)
  {
    temp=value % 16;
    value=value/16;
    if(temp>=0 && temp<=9)
      string[i-1]=temp+0x30;
    else string[i-1]=temp+0x37;
  }
}
/*--------------------------------------------------------*/
locate(row,col) /* locate cursor position */
int row,col;
{
  union REGS inregs;

  inregs.h.ah=15;/*read back video status */
  int86(VIDEO,&inregs,&inregs);
  inregs.h.dh=row;
  inregs.h.dl=col;
  inregs.h.ah=2;/*cursor position */
  int86(VIDEO,&inregs,&inregs);
}
/*--------------------------------------------------------*/
clscrn(row1,col1,row2,col2) /* clear window screen */
int row1,col1,row2,col2;
{
  union REGS inregs;

  inregs.h.ah=6;/* scroll up */
  inregs.h.al=0;/* window all scroll up out */
  inregs.h.ch=row1;
  inregs.h.cl=col1;
  inregs.h.dh=row2;
  inregs.h.dl=col2;
  inregs.h.bh=7;/* scroll up lines are normal attr */
  int86(VIDEO,&inregs,&inregs);
}
/*--------------------------------------------------------*/
curpos(rowptr,colptr) /* read cursor position */
int *rowptr,*colptr;
{
  union REGS inregs;

  inregs.h.ah=15; /* read status */
  int86(VIDEO,&inregs,&inregs);
  inregs.h.ah=3; /* read cursor position */
  int86(VIDEO,&inregs,&inregs);
  *rowptr=inregs.h.dh;
  *colptr=inregs.h.dl;
}
/*--------------------------------------------------------*/
curchar(charptr,attrptr) /* read cursor character,attr */
int *charptr,*attrptr;
{
  union REGS inregs;

  inregs.h.ah=15; /* read status */
  int86(VIDEO,&inregs,&inregs);
  inregs.h.ah=8; /* read cursor character */
  int86(VIDEO,&inregs,&inregs);
  *charptr=inregs.h.al;
  *attrptr=inregs.h.ah;
}
/*--------------------------------------------------------*/
chkcur(row,col,code) /* check character code */
int row,col,code;
{
  int rowtmp,coltmp,error,chartmp,attrtmp;

  curpos(&rowtmp,&coltmp);
  locate(row,col);
  curchar(&chartmp,&attrtmp);
  if((chartmp&0xff) == (code&0xff))
    error=0;
  else error=1;
  locate(rowtmp,coltmp);
  return(error);
}
/*--------------------------------------------------------*/
