/* main c program testprob.c */
/* expro-40 testing program V1.0 */
/* By Grason Kirk 5/30/88 */
/* rev v1.00  */

#include <testpro.dcl>
#define TTLID 0xe0 /* 40 bit i/o */

#define VOPID 0xe5 /* 8 bit D/A 0.1 res */
#define VHHID 0xe6 /* 8 bit D/A 0.06 res */
#define VCCID 0xe7 /* 8 bit D/A 0.04 res */

#define VOPENID 0xe8 /* 40 bit output enable only bit8-bit31*/
#define VHHENID 0xf0 /* 40 bit output enable only bit8-bit31*/
#define VCCENID 0xed /* 16 bit output enable only VCC pin */
#define VHHENCID 0xf5 /*16 bit output enable only VCC in 24 pin */

#define OTHERENID 0xef /* gnd,vopx7,vopx25,odc48,osc51,freg */
#define CODEID 0xf8 /* ID code port */
/*=========================================================*/
extern dly50m(),dly1m(),dly01m(),dly05m();
extern dly10m(),dly05m(),dly02m();
/*=========================================================*/
extern int idport,dataport;

byte ttlodat[5];
byte vopdat,vhhdat,vccdat;
byte vopen[5],vhhen[5];
byte vccen[2],vhhenc[2];
byte otheren;
/*--------------------------------------------------------------*/
/* basic I/O hardware c function call here */
/*--------------------------------------------------------------*/
power_menu()
{
  window(0,40,23,78);
  locate(0,45);
    printf("   Power supply test   ");

  locate(1,41);
    printf("Measuring the following point on");
  locate(2,41);
    printf("connector J2 or test point by DVM,");
  locate(3,41);
    printf("and the value has to be in the");
  locate(4,41);
    printf("specified limit");
  locate(5,41);
    printf("Gound point at P1 of J2");

  locate(7,41);
    printf("  J2     MIN.    TYP.     MAX.");
  locate(8,41);
    printf("P2,P39   4.75V   5.00V    5.25V");
  locate(9,41);
    printf("P3,P38   10.8V   12.0V    13.2V");

  locate(10,41);
    printf("(TP30V)    27.5V   30.5V    33.5V");
  locate(11,41);
    printf("(TP20V)    17.3V   19.2V    21.2V");
  locate(12,41);
    printf("(TP8V)     7.2V    8.0V     8.8V");

  locate(14,41);
    printf("TP30V is collecter of Q5-TIP31");
  locate(15,41);
    printf("TP20V is collecter of Q1-TIP31");
  locate(16,41);
    printf("TP8V  is pin 3 of U38-723C");

  locate(18,41);
    printf("Press any key back to main menu");
  getch();
  clscrn(0,40,23,78);
}
/*--------------------------------------------------------------*/
adj_menu()
{
  window(0,40,23,78);
  locate(0,45);
    printf("   Voltage adjustment   ");

  locate(1,41);
    printf("Measuring and adjusting the follow-");
  locate(2,41);
    printf("ing point on connector J2 by DVM,");
  locate(3,41);
    printf("and the value has to be in the");
  locate(4,41);
    printf("specified limit");
  locate(5,41);
    printf("Gound point at P20 of J2");

  locate(7,41);
    printf("  J2     MIN.   TYP.   MAX.   ADJ.");
  locate(8,41);
    printf("P17,P24   7.9V   8.0V   8.1V  VR3");
  locate(9,41);
    printf("P18,P23  15.2V  15.3V  15.4V  VR2");
  locate(10,41);
    printf("P19,P22  25.4V  25.5V  25.6V  VR1");

  locate(15,41);
    printf("Press any key back to main menu");

  setvcc(200);
  dly1m();
  setvhh(0xff);
  dly1m();
  setvop(0xff);
  dly1m();
  getch();
  initio();
  clscrn(0,40,23,78);
}
/*--------------------------------------------------------------*/
gndtest()
{
  int ch,step;

  step=0;
  window(0,40,23,78);
  locate(0,45);
    printf("   GND pin test   ");

  locate(1,41);
    printf("There are 2 GND pins on test-socket");
  locate(2,41);
    printf("have to be tested by DVM,");
  locate(3,41);
    printf("and the value has to be in the");
  locate(4,41);
    printf("specified limit");
  locate(5,41);
    printf("Gound point at P20 of J2");

  locate(7,41);
    printf("test-socket   MIN.    TYP.    MAX.");
  locate(8,41);
    printf(" STEP 1:P20   0V      0.1V    0.2V");
  locate(9,41);
    printf("      P11,P30 4.9V    5.0V    5.1V");
  locate(11,41);
    printf(" STEP 2:P20   4.9V    5.0V    5.1V");
  locate(12,41);
    printf("      P11,P30  0V     0.1V    0.2V");

  locate(15,41);
    printf("Press 'S' key to change testing step");
  locate(16,41);
    printf("Press <CR> back to main menu");

  locate(8,41);
  setvcc(125);/* vcc 5V out put */

  while(TRUE)
  {
    while((ch=getch())==0)
      getch();
    if(ch==CR || ch==LF || ch==ESC)
      break;
    ch=toupper(ch);
    if(ch=='S')
    {
      if(step==0)
      {
        locate(11,41);
        step=1;
        outp(idport,OTHERENID);
        outp(dataport,0x01);        
      }
      else
      {
        locate(8,41);
        step=0;
        outp(idport,OTHERENID);
        outp(dataport,0x00);        
      }
    }
  }
  initio();
  clscrn(0,40,23,78);
}
/*--------------------------------------------------------------*/
vcctest()
{
  int ch,step,i;

  step=0;
  clscrn(0,0,24,79);
  locate(0,0);
    printf("   VCC pin test :\n");
    printf("There are 14 VCC pins on test-socket have to be tested by DVM,\n");
    printf("and the value has to be in specified limit\n");
    printf("Gound point at P20 of test-socket\n\n");

    printf("                            test-socket pin\n");
    printf("                1  5  7  9  26 27 28 29 30 31 32 34 36 40\n");
    printf("   STEP   01    1  0  0  0  0  0  0  0  0  0  0  0  0  0\n");
    printf("       1 : 4.9V to 5.1V\n");
    printf("       0 : 0V   to 0.2V\n");
    printf("\n");
 
    printf("Press 'S' key to change testing step\n");
    printf("Press <CR> back to main menu");

  locate(7,16);
  setvcc(125);/* vcc 5V out put */
  dly1m();
  vccen[0]=0,vccen[1]=0x20;
  ttlodat[0]=0x01,ttlodat[1]=0,ttlodat[2]=0,ttlodat[3]=0,ttlodat[4]=0;
  while(TRUE)
  {
    outp(idport,TTLID+0);
    outp(dataport,ttlodat[0]);
    outp(idport,TTLID+1);
    outp(dataport,ttlodat[1]);
    outp(idport,TTLID+2);
    outp(dataport,ttlodat[2]);
    outp(idport,TTLID+3);
    outp(dataport,ttlodat[3]);
    outp(idport,TTLID+4);
    outp(dataport,ttlodat[4]);

    outp(idport,VCCENID+0);
    outp(dataport,vccen[0]);
    outp(idport,VCCENID+1);
    outp(dataport,vccen[1]);


    while((ch=getch())==0)
      getch();
    if(ch==CR || ch==LF || ch==ESC)
      break;
    ch=toupper(ch);
    if(ch=='S')
    {
      step++;
      if(step==14)
        step=0;
      locate(7,10);
        printf("%02d",step+1);
      locate(7,16);
        for(i=0;i<14;i++)
        {
          if(i==step)
            printf("1  ");
          else printf("0  ");
        }
      locate(7,16+step*3);
    }
    switch(step)
    {
      case 0:vccen[0]=0,vccen[1]=0x20;
             ttlodat[0]=0x01,ttlodat[1]=0,ttlodat[3]=0,ttlodat[4]=0;
             break;
      case 1:vccen[0]=0,vccen[1]=0x10;
             ttlodat[0]=0x10,ttlodat[1]=0,ttlodat[3]=0,ttlodat[4]=0;
             break;
      case 2:vccen[0]=0,vccen[1]=0x08;
             ttlodat[0]=0x40,ttlodat[1]=0,ttlodat[3]=0,ttlodat[4]=0;
             break;
      case 3:vccen[0]=0,vccen[1]=0x04;
             ttlodat[0]=0,ttlodat[1]=0x01,ttlodat[3]=0,ttlodat[4]=0;
             break;
      case 4:vccen[0]=0,vccen[1]=0x02;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0x02,ttlodat[4]=0;
             break;
      case 5:vccen[0]=0,vccen[1]=0x01;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0x04,ttlodat[4]=0;
             break;
      case 6:vccen[0]=0x80,vccen[1]=0;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0x08,ttlodat[4]=0;
             break;
      case 7:vccen[0]=0x40,vccen[1]=0;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0x10,ttlodat[4]=0;
             break;
      case 8:vccen[0]=0x20,vccen[1]=0;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0x20,ttlodat[4]=0;
             break;
      case 9:vccen[0]=0x10,vccen[1]=0;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0x40,ttlodat[4]=0;
             break;
      case 10:vccen[0]=0x08,vccen[1]=0;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0x80,ttlodat[4]=0;
             break;
      case 11:vccen[0]=0x04,vccen[1]=0;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0,ttlodat[4]=0x02;
             break;
      case 12:vccen[0]=0x02,vccen[1]=0;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0,ttlodat[4]=0x08;
             break;
      case 13:vccen[0]=0x01,vccen[1]=0;
             ttlodat[0]=0,ttlodat[1]=0,ttlodat[3]=0,ttlodat[4]=0x80;
             break;
    }
  }
  initio();
  clscrn(0,40,23,78);
}
/*--------------------------------------------------------------*/
vhhtest()
{
  int ch,step,i;

  step=0;
  clscrn(0,0,24,79);
  locate(0,0);
    printf("   VHH pin test :\n");
    printf("There are 23 VHH pins on test-socket have to be tested by DVM,\n");
    printf("and the value has to be in specified limit\n");
    printf("Gound point at P20 of test-socket\n\n");

printf("                            test-socket pin\n");
printf(\
"        9  10 11 12 13 14 15 16 17 18 19 21 22 23 24 25 26 27 28 29 30 31 32\n");
printf(\
"STEP 01 1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0\n");
printf("       1 : 11.0V to 11.5V\n");
printf("       0 : 4.9V  to 5.1V\n");
printf("\n");
 
    printf("Press 'S' key to change testing step\n");
    printf("Press <CR> back to main menu");

  locate(7,8);
  setvcc(125);/* vcc 5V out put */
  dly1m();
  setvhh(200);/* vhh 12V output */
  dly1m();
  vhhen[1]=0x01,vhhen[2]=0,vhhen[3]=0;
  while(TRUE)
  {
    outp(idport,VHHENID+1);
    outp(dataport,vhhen[1]);
    outp(idport,VHHENID+2);
    outp(dataport,vhhen[2]);
    outp(idport,VHHENID+3);
    outp(dataport,vhhen[3]);


    while((ch=getch())==0)
      getch();
    if(ch==CR || ch==LF || ch==ESC)
      break;
    ch=toupper(ch);
    if(ch=='S')
    {
      step++;
      if(step==23)
        step=0;
      locate(7,5);
        printf("%02d",step+1);
      locate(7,8);
        for(i=0;i<23;i++)
        {
          if(i==step)
            printf("1  ");
          else printf("0  ");
        }
      locate(7,8+step*3);
    }
    switch(step)
    {
      case 0:vhhen[1]=0x01,vhhen[2]=0,vhhen[3]=0;
             break;
      case 1:vhhen[1]=0x02,vhhen[2]=0,vhhen[3]=0;
             break;
      case 2:vhhen[1]=0x04,vhhen[2]=0,vhhen[3]=0;
             break;
      case 3:vhhen[1]=0x08,vhhen[2]=0,vhhen[3]=0;
             break;
      case 4:vhhen[1]=0x10,vhhen[2]=0,vhhen[3]=0;
             break;
      case 5:vhhen[1]=0x20,vhhen[2]=0,vhhen[3]=0;
             break;
      case 6:vhhen[1]=0x40,vhhen[2]=0,vhhen[3]=0;
             break;
      case 7:vhhen[1]=0x80,vhhen[2]=0,vhhen[3]=0;
             break;
      case 8:vhhen[1]=0,vhhen[2]=0x01,vhhen[3]=0;
             break;
      case 9:vhhen[1]=0,vhhen[2]=0x02,vhhen[3]=0;
             break;
      case 10:vhhen[1]=0,vhhen[2]=0x04,vhhen[3]=0;
             break;
      case 11:vhhen[1]=0,vhhen[2]=0x10,vhhen[3]=0;
             break;
      case 12:vhhen[1]=0,vhhen[2]=0x20,vhhen[3]=0;
             break;
      case 13:vhhen[1]=0,vhhen[2]=0x40,vhhen[3]=0;
             break;
      case 14:vhhen[1]=0,vhhen[2]=0x80,vhhen[3]=0;
             break;
      case 15:vhhen[1]=0,vhhen[2]=0,vhhen[3]=0x01;
             break;
      case 16:vhhen[1]=0,vhhen[2]=0,vhhen[3]=0x02;
             break;
      case 17:vhhen[1]=0,vhhen[2]=0,vhhen[3]=0x04;
             break;
      case 18:vhhen[1]=0,vhhen[2]=0,vhhen[3]=0x08;
             break;
      case 19:vhhen[1]=0,vhhen[2]=0,vhhen[3]=0x10;
             break;
      case 20:vhhen[1]=0,vhhen[2]=0,vhhen[3]=0x20;
             break;
      case 21:vhhen[1]=0,vhhen[2]=0,vhhen[3]=0x40;
             break;
      case 22:vhhen[1]=0,vhhen[2]=0,vhhen[3]=0x80;
             break;
    }
  }
  initio();
  clscrn(0,40,23,78);
}
/*--------------------------------------------------------------*/
voptest()
{
  int ch,step,i;

  step=0;
  clscrn(0,0,24,79);
  locate(0,0);
    printf("   VOP pin test :\n");
    printf("There are 23 VOP pins on test-socket have to be tested by DVM,\n");
    printf("and the value has to be in specified limit\n");
    printf("Gound point at P20 of test-socket\n\n");

printf("                            test-socket pin\n");
printf(\
"        9  10 11 12 13 14 15 16 17 18 19 21 22 23 24 25 26 27 28 29 30 31 32\n");
printf(\
"STEP 01 1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0\n");
printf("       1 : 19.5V to 20.5V\n");
printf("       0 : 4.9V  to 5.1V\n");
printf("\n");
 
    printf("Press 'S' key to change testing step\n");
    printf("Press <CR> back to main menu");

  locate(7,8);
  setvcc(125);/* vcc 5V out put */
  dly1m();
  setvop(210);/* vop 21V output */
  dly1m();
  vopen[1]=0x01,vopen[2]=0,vopen[3]=0;
  while(TRUE)
  {
    outp(idport,VOPENID+1);
    outp(dataport,vopen[1]);
    outp(idport,VOPENID+2);
    outp(dataport,vopen[2]);
    outp(idport,VOPENID+3);
    outp(dataport,vopen[3]);


    while((ch=getch())==0)
      getch();
    if(ch==CR || ch==LF || ch==ESC)
      break;
    ch=toupper(ch);
    if(ch=='S')
    {
      step++;
      if(step==23)
        step=0;
      locate(7,5);
        printf("%02d",step+1);
      locate(7,8);
        for(i=0;i<23;i++)
        {
          if(i==step)
            printf("1  ");
          else printf("0  ");
        }
      locate(7,8+step*3);
    }
    switch(step)
    {
      case 0:vopen[1]=0x01,vopen[2]=0,vopen[3]=0;
             break;
      case 1:vopen[1]=0x02,vopen[2]=0,vopen[3]=0;
             break;
      case 2:vopen[1]=0x04,vopen[2]=0,vopen[3]=0;
             break;
      case 3:vopen[1]=0x08,vopen[2]=0,vopen[3]=0;
             break;
      case 4:vopen[1]=0x10,vopen[2]=0,vopen[3]=0;
             break;
      case 5:vopen[1]=0x20,vopen[2]=0,vopen[3]=0;
             break;
      case 6:vopen[1]=0x40,vopen[2]=0,vopen[3]=0;
             break;
      case 7:vopen[1]=0x80,vopen[2]=0,vopen[3]=0;
             break;
      case 8:vopen[1]=0,vopen[2]=0x01,vopen[3]=0;
             break;
      case 9:vopen[1]=0,vopen[2]=0x02,vopen[3]=0;
             break;
      case 10:vopen[1]=0,vopen[2]=0x04,vopen[3]=0;
             break;
      case 11:vopen[1]=0,vopen[2]=0x10,vopen[3]=0;
             break;
      case 12:vopen[1]=0,vopen[2]=0x20,vopen[3]=0;
             break;
      case 13:vopen[1]=0,vopen[2]=0x40,vopen[3]=0;
             break;
      case 14:vopen[1]=0,vopen[2]=0x80,vopen[3]=0;
             break;
      case 15:vopen[1]=0,vopen[2]=0,vopen[3]=0x01;
             break;
      case 16:vopen[1]=0,vopen[2]=0,vopen[3]=0x02;
             break;
      case 17:vopen[1]=0,vopen[2]=0,vopen[3]=0x04;
             break;
      case 18:vopen[1]=0,vopen[2]=0,vopen[3]=0x08;
             break;
      case 19:vopen[1]=0,vopen[2]=0,vopen[3]=0x10;
             break;
      case 20:vopen[1]=0,vopen[2]=0,vopen[3]=0x20;
             break;
      case 21:vopen[1]=0,vopen[2]=0,vopen[3]=0x40;
             break;
      case 22:vopen[1]=0,vopen[2]=0,vopen[3]=0x80;
             break;
    }
  }
  initio();
  clscrn(0,40,23,78);
}
/*--------------------------------------------------------------*/
iotest()
{
  int ch,step,i;
  byte ttlin[5];

  step=0;
  clscrn(0,0,24,79);
  locate(0,0);
    printf("   I/O pin test :\n");
    printf("There are 39 I/O pins on test-socket have to be tested by DVM,\n");
    printf("and the value has to be in specified limit\n");
    printf("Gound point at P20 of test-socket\n\n");

printf("                            test-socket pin\n");
printf(\
"STEP 01 1  2  3  4  5  6  7  8  9  10 11 12 13 14 15 16 17 18 19 20\n");
printf(\
"OUTPUT  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0\n");
printf(\
"INPUT   1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0\n");
printf("\n");

printf(\
"        21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40\n");
printf(\
"OUTPUT  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0\n");
printf(\
"INPUT   0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0\n");

printf("Measuring test-socket pin for 1 : 4.9V to  5.1V\n");
printf("                              0 : 0V   to  0.2V\n");
printf("Don't care about P20\n");
printf("OUTPUT means : software output to test-socket\n");
printf("INPUT  means : software automatically test the output feedback\n");
printf("       If there are any difference between OUTPUT and INPUT,\n");
printf("       the test is failure also.\n");
printf("\n");
 
    printf("Press 'S' key to change testing step\n");
    printf("Press <CR> back to main menu");

  locate(7,8);
  setvcc(125);/* vcc 5V out put */
  dly1m();
  ttlodat[0]=0x01,ttlodat[1]=0,ttlodat[2]=0,ttlodat[3]=0,ttlodat[4]=0;
  while(TRUE)
  {
    for(i=0;i<5;i++)
    {
    outp(idport,TTLID+i);
    outp(dataport,ttlodat[i]);
    }

    locate(6,5);
      printf("%02d",step+1);

    locate(7,8);
    for(i=0;i<20;i++)
      printf("0  ");
    locate(11,8);
    for(i=0;i<20;i++)
      printf("0  ");
    if(step<20)
    {
      locate(7,8+step*3);
        printf("1  ");
    }
    else
    {
      locate(11,8+(step-20)*3);
        printf("1  ");
    }

    for(i=0;i<5;i++)
    {
    outp(idport,TTLID+i);
    ttlin[i]=inp(dataport);
    }
    locate(8,8);
      bindsp2(ttlin[0]);
    locate(8,8+24);
      bindsp2(ttlin[1]);
    locate(8,8+24+24);
      for(i=0;i<4;i++)
      {
        if((ttlin[2] & (0x01<<i))==0)
          printf("0  ");
        else
          printf("1  ");
      }
    locate(12,8);
      for(i=0;i<4;i++)
      {
        if((ttlin[2] & (0x01<<i+4))==0)
          printf("0  ");
        else
          printf("1  ");
      }

    locate(12,8+12);
      bindsp2(ttlin[3]);
    locate(12,8+12+24);
      bindsp2(ttlin[4]);

    if(step<20)
      locate(7,8+step*3);
    else
      locate(11,8+(step-20)*3);

    while((ch=getch())==0)
      getch();
    if(ch==CR || ch==LF || ch==ESC)
      break;
    ch=toupper(ch);
    if(ch=='S')
    {
      step++;
      if(step==40)
        step=0;
      for(i=0;i<5;i++)
        ttlodat[i]=0;
      if(step<8)
        ttlodat[0]=0x01 << step;
      else if(step<16)
        ttlodat[1]=0x01 << (step-8);
      else if(step<24)
        ttlodat[2]=0x01 << (step-16);
      else if(step<32)
        ttlodat[3]=0x01 << (step-24);
      else
        ttlodat[4]=0x01 << (step-32);
    }
  }
  initio();
  clscrn(0,40,23,78);
}
/*--------------------------------------------------------------*/
bindsp2(data)
int data;
{
  int i;

  for(i=0;i<8;i++)
  {
    if((data & (0x01<<i))==0)
      printf("0  ");
    else
      printf("1  ");
  }
}
/*--------------------------------------------------------------*/
xtratest()
{
  int ch,step;

  clscrn(0,0,24,79);
  locate(0,0);
    printf("   EXTRA pin test\n");
    printf("There are 14 extra pins on test-socket have to be tested,\n");
    printf("and the value has to be in the specified limit\n");
    printf("Gound point at P20 of test-socket\n\n");

    printf("  STEP 1  P32      11.0V to 11.5V, others are 4.9V to 5.1V\n");
    printf("  STEP 2  P31      11.0V to 11.5V, others are 4.9V to 5.1V\n");
    printf("  STEP 3  P30      11.0V to 11.5V, others are 4.9V to 5.1V\n");
    printf("  STEP 4  P29      11.0V to 11.5V, others are 4.9V to 5.1V\n");
    printf("  STEP 5  P28      11.0V to 11.5V, others are 4.9V to 5.1V\n");
    printf("  STEP 6  P1       19.5V to 20.5V, others are 4.9V to 5.1V\n");
    printf("  STEP 7  P5       19.5V to 20.5V, others are 4.9V to 5.1V\n");
    printf("  STEP 8  P7       19.5V to 20.5V, others are 4.9V to 5.1V\n");
    printf("  STEP 9  P7         17.0V to 18.0V, others are 4.9V to 5.1V\n");
    printf("  STEP 10 P25        17.0V to 18.0V, others are 4.9V to 5.1V\n");
    printf("  STEP 11 P2,P3      2.215 MHZ OSC, others are 4.9V to 5.1V\n");
    printf("  STEP 12 P18,P19    4.430 MHZ OSC, others are 4.9V to 5.1V\n");

  locate(20,0);
    printf("Press 'S' key to change testing step");
  locate(21,0);
    printf("Press <CR> back to main menu");

  step=0;
  locate(5,1);
  setvcc(125);/* vcc 5V out put */
  dly1m();
  setvhh(200);/* vhh 12V out put */
  dly1m();
  setvop(210);/* vop 21V out put */
  dly1m();
  vhhenc[0]=0x08,vopen[0]=0,otheren=0;
               outp(idport,VHHENCID+0);
               outp(dataport,vhhenc[0]);
               outp(idport,VOPENID+0);
               outp(dataport,vopen[0]);
               outp(idport,OTHERENID);
               outp(dataport,otheren);
  while(TRUE)
  {
    while((ch=getch())==0)
      getch();
    if(ch==CR || ch==LF || ch==ESC)
      break;
    ch=toupper(ch);
    if(ch=='S')
    {
      step++;
      if(step==12)
        step=0;
      locate(5+step,1);
      switch(step)
      {
        case 0:vhhenc[0]=0x08,vopen[0]=0,otheren=0;
               outp(idport,VHHENCID+0);
               outp(dataport,vhhenc[0]);
               outp(idport,VOPENID+0);
               outp(dataport,vopen[0]);
               outp(idport,OTHERENID);
               outp(dataport,otheren);
               break;
        case 1:vhhenc[0]=0x10;
               outp(idport,VHHENCID+0);
               outp(dataport,vhhenc[0]);
               break;
        case 2:vhhenc[0]=0x20;
               outp(idport,VHHENCID+0);
               outp(dataport,vhhenc[0]);
               break;
        case 3:vhhenc[0]=0x40;
               outp(idport,VHHENCID+0);
               outp(dataport,vhhenc[0]);
               break;
        case 4:vhhenc[0]=0x80;
               outp(idport,VHHENCID+0);
               outp(dataport,vhhenc[0]);
               break;
        case 5:vhhenc[0]=0,vopen[0]=0x01;
               outp(idport,VHHENCID+0);
               outp(dataport,vhhenc[0]);
               outp(idport,VOPENID+0);
               outp(dataport,vopen[0]);
               break;
        case 6:vopen[0]=0x10;
               outp(idport,VOPENID+0);
               outp(dataport,vopen[0]);
               break;
        case 7:vopen[0]=0x40;
               outp(idport,VOPENID+0);
               outp(dataport,vopen[0]);
               break;
        case 8:vopen[0]=0,otheren=0x02;
               outp(idport,VOPENID+0);
               outp(dataport,vopen[0]);
               outp(idport,OTHERENID);
               outp(dataport,otheren);
               break;
        case 9:otheren=0x04;
               outp(idport,OTHERENID);
               outp(dataport,otheren);
               break;
        case 10:otheren=0x08;
               outp(idport,OTHERENID);
               outp(dataport,otheren);
               break;
        case 11:otheren=0x30;
               outp(idport,OTHERENID);
               outp(dataport,otheren);
               break;
      }
    }
  }
  initio();
  clscrn(0,40,23,78);
}
/*==============================================================*/
initio()
{
  int i;

  for(i=0;i<5;i++)
  {
    ttlodat[i]=0xff;
    vopen[i]=0;
    vhhen[i]=0;
  }
  vopdat=0,vhhdat=0,vccdat=0;
  otheren=0;
  for(i=0;i<2;i++)
  {
    vccen[i]=0;
    vhhenc[i]=0;
  }

  for(i=0;i<5;i++)
  {
    outp(idport,TTLID+i);
    outp(dataport,ttlodat[i]);
    outp(idport,VOPENID+i);
    outp(dataport,vopen[i]);
    outp(idport,VHHENID+i);
    outp(dataport,vhhen[i]);
  }
  for(i=0;i<2;i++)
  {
    outp(idport,VCCENID+i);
    outp(dataport,vccen[i]);
    outp(idport,VHHENCID+i);
    outp(dataport,vhhenc[i]);
  }
  outp(idport,VOPID);
  outp(dataport,vopdat);
  outp(idport,VHHID);
  outp(dataport,vhhdat);
  outp(idport,VCCID);
  outp(dataport,vccdat);

  outp(idport,OTHERENID);
  outp(dataport,otheren);
}
/*-------------------------------------------------------------*/
defio()
{
  initio();
}
/*-------------------------------------------------------------*/
setvop(data)
int data;
{
  outp(idport,VOPID);
  outp(dataport,data);
}
setvhh(data)
int data;
{
  outp(idport,VHHID);
  outp(dataport,data);
}
setvcc(data)
int data;
{
  outp(idport,VCCID);
  outp(dataport,data);
}
/*-------------------------------------------------------------*/
